// @\@: ftp T[oƐڑăt@C]s
// g: java MyFTP <T[o>
// N: java MyFTP ftp.ne.jp

import java.net.*;
import java.io.*;

public class MyFTP {
	Socket ctrlSocket;		//p\Pbg
	public PrintWriter ctrlOutput;	//o͗pXg[
	public BufferedReader ctrlInput;// ͗pXg[

	final int CTRLPORT = 21 ;// ftp ̐p|[g
	//------------------------------------------------------------------
	//AhXƃ|[gԍ\Pbg萧pXg[쐬
	public void openConnection(String host)
		throws IOException,UnknownHostException {
		ctrlSocket = new Socket(host, CTRLPORT);
		ctrlOutput = new PrintWriter(ctrlSocket.getOutputStream());
		ctrlInput
			= new BufferedReader(new
				InputStreamReader(ctrlSocket.getInputStream()));
	} // end of openConnection
	//------------------------------------------------------------------
	//p̃\Pbg
	public void closeConnection() throws IOException {
		ctrlSocket.close() ;
	} // end of closeConnection
	//------------------------------------------------------------------
	// ftp T[oɃOC
	public void doLogin() {
		String loginName = "" ;
		String password = "" ;
		BufferedReader lineread
			= new BufferedReader(new InputStreamReader(System.in)) ;

		try {
			System.out.println("OC͂Ă") ;
			loginName = lineread.readLine() ;
			// USERR}hɂ郍OC
			ctrlOutput.println("USER " + loginName) ;
			ctrlOutput.flush() ;
			// PASSR}hɂpX[h̓
			System.out.println("pX[h͂Ă") ;
			password = lineread.readLine() ;
			ctrlOutput.println("PASS " + password) ;
			ctrlOutput.flush() ;
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doLogin
	//------------------------------------------------------------------
	// ftp T[o烍OAEg
	public void doQuit() {
		try {
			ctrlOutput.println("QUIT ") ;// QUITR}h̑M
			ctrlOutput.flush() ;
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doQuit
	//------------------------------------------------------------------
	// fBNgύX
	public void doCd() {
		String dirName = "" ;
		BufferedReader lineread
			= new BufferedReader(new InputStreamReader(System.in)) ;

		try {
			System.out.println("fBNg͂Ă") ;
			dirName = lineread.readLine() ;
			ctrlOutput.println("CWD " + dirName) ;// CWDR}h
			ctrlOutput.flush() ;
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doCd
	//------------------------------------------------------------------
	// fBNg擾
	public void doLs(){
		int n ;
		byte[] buff = new byte[1024] ;
		try {
			// f[^pRlNV쐬
			Socket dataSocket = dataConnection("LIST") ;

			// f[^ǂݎpXg[p
			BufferedInputStream dataInput
				= new BufferedInputStream(dataSocket.getInputStream()) ;

			// fBNgǂ
			while((n = dataInput.read(buff)) > 0){
				System.out.write(buff,0,n) ;
			}
			dataSocket.close() ;
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doLs
	//------------------------------------------------------------------
	// T[oƂ̃f[^pɃ\Pbg܂
	// ܂,T[oɑ΂portR}hŃ|[gʒm܂
	public Socket dataConnection(String ctrlcmd)
	{
		String cmd = "PORT " ; //PORTR}hőf[^̊i[pϐ
		int i ;
		Socket dataSocket = null ;// f[^]p\Pbg
		try {
			// ̃AhX߂
			byte[] address = InetAddress.getLocalHost().getAddress() ;

			// Kȃ|[gԍ̃T[o\Pbg쐬
			ServerSocket serverDataSocket = new ServerSocket(0,1) ;

			// PORTR}hp̑Mf[^쐬
			for(i = 0; i < 4; ++i)
				cmd = cmd + (address[i] & 0xff) + "," ;
			cmd = cmd + (((serverDataSocket.getLocalPort()) / 256) & 0xff)
					  + ","
					  + (serverDataSocket.getLocalPort() & 0xff) ;

			// PORTR}h𐧌pXg[ʂđ
			ctrlOutput.println(cmd) ;
			ctrlOutput.flush() ;

			// ΏۃR}h(LIST,RETR,STORjT[oɑ
			ctrlOutput.println(ctrlcmd) ;
			ctrlOutput.flush() ;

			// T[o̐ڑ󂯕t
			dataSocket = serverDataSocket.accept() ;
			serverDataSocket.close() ;
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		return dataSocket ;
	} // end of dataConnection
	//------------------------------------------------------------------
	// T[õt@C擾
	public void doGet() {
		String fileName = "" ;
		BufferedReader lineread
		= new BufferedReader(new InputStreamReader(System.in)) ;
			int n ;
			byte[] buff = new byte[1024] ;

		try {
			// T[ot@C̃t@Cw肵܂
			System.out.println("t@C͂Ă") ;
			fileName = lineread.readLine() ;

			// NCAgɎMpt@C
			FileOutputStream outfile = new FileOutputStream(fileName) ;

			// t@C]pf[^Xg[쐬
			Socket dataSocket = dataConnection("RETR " + fileName) ;
			BufferedInputStream dataInput
				= new BufferedInputStream(dataSocket.getInputStream()) ;

			// T[of[^󂯎,t@CɊi[
			while((n = dataInput.read(buff)) > 0){
				outfile.write(buff,0,n) ;
			}
			dataSocket.close() ;
			outfile.close() ;
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doGet
	//------------------------------------------------------------------
	// T[oփt@C𑗂܂
	public void doPut() {
		String fileName = "" ;
		BufferedReader lineread
			= new BufferedReader(new InputStreamReader(System.in)) ;
		int n ;
		byte[] buff = new byte[1024] ;

		try {
			System.out.println("Input File Name: ") ;
			fileName = lineread.readLine() ;

			// NCAg̃t@C̓ǂݏos܂
			FileInputStream sendfile = new FileInputStream(fileName) ;

			// ]pf[^Xg[pӂ܂
			Socket dataSocket = dataConnection("STOR " + fileName) ;
			OutputStream outstr = dataSocket.getOutputStream();

			// t@Cǂݏo,lbg[NoRŃT[oɑ
			while((n = sendfile.read(buff)) > 0){
				outstr.write(buff,0,n) ;
			}
			dataSocket.close() ;
			sendfile.close() ;
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of doPut
	//------------------------------------------------------------------
	// Ftp ̃R}hj[o
	public void showMenu()
	{
		System.out.println("Input Command: ") ;
		System.out.print("1(login)") ;
		System.out.print("   2(ls)") ;
		System.out.print("   3(cd)") ;
		System.out.print("   4(get)") ;
		System.out.print("   5(put)") ;
		System.out.println("   9(quit)") ;
	} // end of showMenu
	//------------------------------------------------------------------
	// R}h
	public String getCommand()
	{
		String buf = "" ;
		BufferedReader lineread
			= new BufferedReader(new InputStreamReader(System.in)) ;
		while(buf.length() != 1){// P̓͂󂯂܂ŌJԂ
			try {
				buf = lineread.readLine() ;
			} catch(Exception e) {
				e.printStackTrace();
				System.exit(1);
			}
		}
		return (buf) ;
	} // end of getCommand
	//------------------------------------------------------------------
	// R}hɑΉeĂяo
	public boolean execCommand(String command)
	{
		boolean cont = true ;
		switch (Integer.parseInt(command)){
		case 1 : // login 
			doLogin() ;
			break ;
		case 2 : // T[õfBNg\
			doLs() ;
			break ;
		case 3 : // T[o̍ƃfBNgύX
			doCd() ;
			break ;
		case 4 : // T[õt@C擾
			doGet() ;
			break ;
		case 5 : // T[oւ̃t@C]
			doPut() ;
			break ;
		case 9 : // ̏I
			doQuit() ;
			cont = false ;
			break ;
		default : //ȊO̓
			System.out.println("ԍIĂ") ;
		}
		return(cont) ;
	} // end of execCommand
	//------------------------------------------------------------------
	// Ftp ̃R}hj[o͂,eĂяo܂
	public void main_proc()
		throws IOException
	{
		boolean cont = true ;
		try {
			while(cont){
				// j[o͂܂
				showMenu() ;
				// R}h󂯎s܂
				cont = execCommand(getCommand()) ;
			}
		}
		catch (Exception e) {
			System.err.print(e);
			System.exit(1);
		}
	} // end of main_proc
	//------------------------------------------------------------------
	// Xg[̎MXbhJn܂
	public void getMsgs(){
		try {
			CtrlListen listener = new CtrlListen(ctrlInput) ;
			Thread listenerthread = new Thread(listener) ;
			listenerthread.start() ;
		} catch (Exception e) {
			e.printStackTrace() ;
			System.exit(1) ;
		}
	} // end of getMsgs
	//------------------------------------------------------------------
	// TCPRlNVJďJn܂
	public static void main(String[] arg){
		if (arg.length != 1) {
			System.out.println("Usage: MyFTP <server addr>");
			System.exit(1);
		}
		try {
			MyFTP f = null;
			f = new MyFTP();
			f.openConnection(arg[0]);	// pRlNV̐ݒ
			f.getMsgs() ;				// MXbh̊Jn
System.out.println("309");
			f.main_proc();				// ftp 
System.out.println("311");

			f.closeConnection() ;		// RlNṼN[Y
			System.exit(0) ;			// vȌI
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	} // end of main
} // end of class MyFTP
//=============================================================================
// CtrlListen NX
class CtrlListen implements Runnable{
	BufferedReader ctrlInput = null ;
	// RXgN^ǂݎ̎w
	public CtrlListen(BufferedReader in){
		ctrlInput = in ;
	}

	public void run(){
		while(true){
			try { // sǂݎCWo͂ɃRs[
				System.out.println(ctrlInput.readLine()) ;
			} catch (Exception e){
				System.exit(1) ;
			}
		}
	}
} // end of class CtrlListen
